diff --git a/src/src/miscmods/dmarc_native.c b/src/src/miscmods/dmarc_native.c
new file mode 100644
index 000000000..ce4aaee4f
--- /dev/null
+++ b/src/src/miscmods/dmarc_native.c
@@ -0,0 +1,707 @@
+/*************************************************
+*     Exim - an Internet mail transport agent    *
+*************************************************/
+
+/* DMARC support.
+   Copyright (c) The Exim Maintainers 2025
+   License: GPL */
+/* SPDX-License-Identifier: GPL-2.0-or-later */
+
+#include "../exim.h"
+
+#ifdef SUPPORT_DMARC
+# error Build cannot support both libopendmarc and native DMARC modules
+#endif
+
+#ifdef EXPERIMENTAL_DMARC_NATIVE
+# ifndef EXIM_HAVE_SPF
+#  error SPF must also be enabled for DMARC
+# elif defined DISABLE_DKIM
+#  error DKIM must also be enabled for DMARC
+# elif !defined LOOKUP_PSL
+#  error PSL lookups must be enabled for DMARC
+# else
+
+#  include "../functions.h"
+#  include "pdkim.h"
+
+extern void		dmarc_send_forensic_report(const uschar **);
+extern const uschar *	dmarc_get_dns_policy_record(uschar **);
+extern void		dmarc_write_history_file(const gstring *);
+extern const uschar *	dmarc_lookup_regdom(const uschar *);
+
+
+static const pcre2_code * dmarc_regex_uri = NULL;
+static const pcre2_code * dmarc_regex_pct = NULL;
+static const pcre2_code * dmarc_regex_ri = NULL;
+static const pcre2_code * dmarc_regex_fo = NULL;
+
+BOOL
+dmarc_local_init(void)
+{
+if (!dmarc_regex_uri)
+  dmarc_regex_uri = regex_must_compile(US "^mailto:[^@]+@[^ !]+(?:[ !]|$)",
+							MCS_CACHEABLE, FALSE);
+if (!dmarc_regex_pct)
+  dmarc_regex_uri = regex_must_compile(US "^\\d{1,3}$",  MCS_CACHEABLE, FALSE);
+if (!dmarc_regex_ri)
+  dmarc_regex_ri =  regex_must_compile(US "^\\d{1,10}$", MCS_CACHEABLE, FALSE);
+if (!dmarc_regex_fo)
+  dmarc_regex_fo =  regex_must_compile(US "^[01ds]$",    MCS_CACHEABLE, FALSE);
+}
+
+
+#include "../version.h"
+
+gstring *
+dmarc_version_report(gstring * g)
+{
+/*
+return string_fmt_append(g, "Library version: dmarc: Compile: %d.%d.%d.%d\n",
+    (OPENDMARC_LIB_VERSION & 0xff000000) >> 24,
+    (OPENDMARC_LIB_VERSION & 0x00ff0000) >> 16,
+    (OPENDMARC_LIB_VERSION & 0x0000ff00) >> 8,
+    (OPENDMARC_LIB_VERSION & 0x000000ff));
+*/
+return string_fmt_append(g, "Library version: dmarc: Exim %s builtin\n",
+			    EXIM_VERSION_STR);
+}
+
+
+int
+dmarc_local_msg_init()
+{
+return OK;
+}
+
+
+/* Convert to comma-sep list to NULL-terminated array of pointers */
+static uschar **
+dmarc_clist_to_array(const uschar * list)
+{
+int cnt = 0, sep = ',';
+const uschar * s = list;
+uschar * buf = store_get(2, list), ** rarray;
+
+while (string_nextinlist(&s, &sep, buf, 1)) cnt++;	/* count the elements */
+rarray = store_get((cnt+1) * sizeof(*rarray), list);
+for (cnt = 0; rarray[cnt] = string_nextinlist(&list, &sep, NULL, 0); ) cnt++;
+return rarray;
+}
+
+
+static void
+dmarc_maybe_send_forensic(const uschar * ruf)
+{
+/* Earlier ACL does not have *required* control=dmarc_enable_forensic */
+if (!f.dmarc_enable_forensic)
+  return;
+
+/* RFC 7489 6.3 - ruf is optional */
+if (!ruf)
+  return;
+
+if (   dmarc_policy == DMARC_POLICY_REJECT
+    && dmarc_action == DMARC_RESULT_REJECT
+   ||  dmarc_policy == DMARC_POLICY_QUARANTINE
+    && dmarc_action == DMARC_RESULT_QUARANTINE
+   ||  dmarc_policy == DMARC_POLICY_NONE
+    && dmarc_action == DMARC_RESULT_REJECT
+   ||  dmarc_policy == DMARC_POLICY_NONE
+    && dmarc_action == DMARC_RESULT_QUARANTINE
+   )
+  {
+/* RFC 7489 6.3 - ruf is a comma-sep list */
+  /* Convert to NULL-terminated array of pointers */
+  const uschar ** rarray = CUSS dmarc_clist_to_array(ruf);
+  dmarc_send_forensic_report(rarray);
+  }
+}
+
+
+/******************************************************************************/
+/* Policy record parsing */
+
+/* Value verification routines: return boolean "good" */
+
+static BOOL dmarc_vfy_vmode(const uschar * val)
+{ return (*val == 's' || *val == 'r') && val[1] == '\0'; }
+static BOOL dmarc_vfy_policy(const uschar * val)
+{ return Ustrcmp(val, "none") == 0
+	|| Ustrcmp(val, "quarantine") == 0
+	|| Ustrcmp(val, "reject") == 0; }
+static BOOL dmarc_vfy_fbl(const uschar * val)
+{
+/* For now, permit a list starting with (a plausible) mailto URI */
+return regex_match(dmarc_regex_uri, val, -1, NULL);
+}
+
+static BOOL dmarc_tag_vfy_adkim(const uschar * val)
+{ return dmarc_vfy_vmode(val); }
+static BOOL dmarc_tag_vfy_aspf(const uschar * val)
+{ return dmarc_vfy_vmode(val); }
+static BOOL dmarc_tag_vfy_fo(const uschar * val)
+{ return regex_match(dmarc_regex_fo, val, -1, NULL); }
+static BOOL dmarc_tag_vfy_p(const uschar * val)
+{ return dmarc_vfy_policy(val); }
+static BOOL dmarc_tag_vfy_pct(const uschar * val)
+{ return regex_match(dmarc_regex_pct, val, -1, NULL); }
+static BOOL dmarc_tag_vfy_rf(const uschar * val)
+{ return Ustrcmp(val, "afrf") == 0; }
+static BOOL dmarc_tag_vfy_ri(const uschar * val)
+{ return regex_match(dmarc_regex_ri, val, -1, NULL); }
+static BOOL dmarc_tag_vfy_rua(const uschar * val)
+{ return dmarc_vfy_fbl(val); }
+static BOOL dmarc_tag_vfy_ruf(const uschar * val)
+{ return dmarc_vfy_fbl(val); }
+static BOOL dmarc_tag_vfy_sp(const uschar * val)
+{ return dmarc_vfy_policy(val); }
+static BOOL dmarc_tag_vfy_v(const uschar * val)
+{ return Ustrcmp(val, "DMARC1") == 0; }
+
+typedef struct dmarc_policy_record {
+  const uschar * adkim;
+  const uschar * aspf;
+  const uschar * fo;
+  const uschar * p;
+  const uschar * pct;
+  const uschar * rf;
+  const uschar * ri;
+  const uschar * rua;
+  const uschar * ruf;
+  const uschar * sp;
+  const uschar * v;
+} dmarc_policy_record;
+
+typedef struct tag {
+  const uschar * name;
+  unsigned	 offset;
+  BOOL		(*verify)(const uschar *);
+} tag;
+#define TAG(field) {.name = US mac_expanded_string(field), \
+		    .offset = offsetof(dmarc_policy_record, field), \
+		    .verify = dmarc_tag_vfy_ ## field }
+tag policy_tags[] = {
+  TAG(adkim),
+  TAG(aspf),
+  TAG(fo),
+  TAG(p),
+  TAG(pct),
+  TAG(rf),
+  TAG(ri),
+  TAG(rua),
+  TAG(ruf),
+  TAG(sp),
+  TAG(v),
+};
+#undef TAG
+
+/* Handle one potential tag
+Return: boolean success; else parsing error
+
+RFC 7489 6.3 :- unknown tags are ignored
+*/
+static int
+parse_tag(const uschar * tagrecord, dmarc_policy_record * prp)
+{
+const uschar * e = Ustrchr(tagrecord, '='), * s;
+
+/* RFC 6736 3.2 tagspec must have = */
+if (!*e)
+  return FALSE;
+
+/* RFC 6736 3.2 ignore whitespace between tag name and = */
+for (s = e; s > tagrecord && isspace(s[-1]); ) s--;
+
+/* RFC 6736 3.2 tag name at least 1 char */
+if (s == tagrecord)
+  return FALSE;
+
+/* search for tag name in our table of known ones */
+for (tag * ptp = policy_tags; ptp < policy_tags + nelem(policy_tags); ptp++)
+ {
+  if (  Ustrncmp(ptp->name, tagrecord, s - tagrecord) == 0
+     && Ustrlen(ptp->name) == s - tagrecord)
+
+    {			/* match; copy tag value to policy record struct */
+    const uschar ** vp = CUSS (US prp + ptp->offset);
+
+// debug_printf_indent("matched %q, off %u\n", tagrecord, ptp->offset);
+
+/* RFC 6736 3.2 ignore whitespace between = and value */
+    s = e + 1;
+    Uskip_whitespace(&s);
+
+    if (!ptp->verify(s)) DEBUG(D_receive)
+      debug_printf_indent("DMARC: bad value for tag %q: %q\n", ptp->name, s);
+    *vp = string_copy(s);
+    break;
+    }
+ }
+return TRUE;
+}
+
+static BOOL
+dmarc_local_parse_policy(const uschar * rr, dmarc_policy_record * prp)
+{
+/* RFC 6376 3.2 :- a taglist is a ;-sep list of tagspec */
+int sep = ';';
+
+/* RFC 6736 3.2 :- ignore whitespace preceding tag-name and after value */
+
+for (uschar * tagspec; tagspec = string_nextinlist(&rr, &sep, NULL, 0); )
+  if (!parse_tag(tagspec, prp))
+    return FALSE;
+
+return TRUE;
+}
+
+/******************************************************************************/
+
+static BOOL
+identifier_aligned(const uschar * a, const uschar * b, const uschar * mode)
+{
+BOOL res;
+
+/* RFC 7489 3.3.1 - In strict mode, only an exact match */
+
+if (*mode == 's')
+  res = Ustrcmp(a, b) == 0;
+
+/* RFC 7489 3.3.1 - In relaxed mode, the Organizational Domains of both */
+else
+  {
+  /* - if there is an exact match, the ODs will also match -
+  so check that first to save on regdom lookups. */
+
+  if (Ustrcmp(a, b) == 0)
+    res = TRUE;
+  else
+    {
+    a = dmarc_lookup_regdom(a);
+    b = dmarc_lookup_regdom(b);
+    res = a && b && Ustrcmp(a, b) == 0;
+    }
+  }
+DEBUG(D_receive)
+  if (res) debug_printf_indent("DMARC aligned(%s) %s %s\n", mode, a, b);
+return res;
+}
+
+
+/* API: dmarc_process adds the envelope sender address to the existing
+context (if any), retrieves the result, sets up expansion
+strings and evaluates the condition outcome.
+Called for the first ACL dmarc= condition. */
+
+int
+dmarc_process(void)
+{
+const uschar * rr;
+BOOL has_dmarc_record = TRUE;
+u_char ** ruf; /* forensic report addressees, if called for */
+
+dmarc_alignment_spf = dmarc_alignment_dkim = FALSE;
+dmarc_dkim_alignment = DMARC_POLICY_DKIM_ALIGNMENT_FAIL;
+dmarc_spf_alignment =  DMARC_POLICY_SPF_ALIGNMENT_FAIL;
+
+/* ACLs have "control=dmarc_disable_verify" */
+if (f.dmarc_disable_verify || dmarc_abort)
+  return OK;
+
+DEBUG(D_receive) { debug_printf_indent("DMARC: process\n"); expand_level++; }
+
+/* Store the header From: sender domain for this part of DMARC.
+If there is no from_header string, then it's likely this message
+is locally generated and relying on fixups to add it.  Just skip
+the entire DMARC system if we can't find a From: header....or if
+there was a previous error.  */
+
+if (!dmarc_from_header)
+  {
+  DEBUG(D_receive) debug_printf_indent("DMARC: no From: header\n");
+  dmarc_abort = TRUE;
+  }
+else
+  {
+/* RFC 7489 6.6.1 :- extract the domain from the 5322.From */
+  const uschar * end_addr, * s;
+  uschar * errormsg;
+  int dummy, domain;
+
+  f.parse_allow_group = TRUE;
+  end_addr = parse_find_address_end(dmarc_from_header, FALSE);
+  s = *end_addr
+      ? string_copyn(dmarc_from_header, end_addr - dmarc_from_header)
+      : dmarc_from_header;
+  if ((dmarc_header_from_sender = parse_extract_address(s, &errormsg,
+			      &dummy, &dummy, &domain, FALSE)))
+    dmarc_header_from_sender += domain;
+
+  /* Only use the domain if not empty.  Otherwise, skip out of DMARC. */
+
+  if (!dmarc_header_from_sender || !*dmarc_header_from_sender)
+    {
+    dmarc_status = US"nofrom";
+    dmarc_pass_fail = US"temperror";
+    dmarc_status_text = US"No From: domain found";
+    dmarc_action = DMARC_RESULT_ACCEPT;
+
+    dmarc_abort = TRUE;
+    }
+  }
+
+/* Skip DMARC if connection is SMTP Auth. Temporarily, admin should
+instead do this in the ACLs.  */
+
+if (!dmarc_abort && !sender_host_authenticated)
+  {
+/* RFC 7489 6.3 :- defaults for policy record tags */
+  dmarc_policy_record dmarc_parsed = {
+    .adkim =	US"r",
+    .aspf =	US"r",
+    .fo =	US"0",
+    .pct =	US"100",
+    .rf =	US"afrf",
+    .ri =	US"86400",
+    };
+
+  int sr = SPF_RESULT_INVALID, spf_origin;
+  uschar * spf_human_readable = NULL, * spf_sender_domain = NULL;
+  unsigned dkim_sig_count = 0;
+  gstring * dkim_history_buffer = NULL;
+  typedef const pdkim_signature * (*sigs_fn_t)(void);
+
+/* RFC 7489 6.6.2 step 2: DMARC policy record from DNS */
+  DEBUG(D_receive)
+    {
+    debug_printf_indent("DMARC: get policy record\n");
+    expand_level++;
+    }
+
+  /* uses $dmarc_header_from_sender */
+  if (!(rr = dmarc_get_dns_policy_record(&dmarc_used_domain)))
+	/*XXX want to handle nxdomain,temprror etc. here */
+    {
+    DEBUG(D_receive) debug_printf_indent("DMARC: no record found for %s\n",
+					  dmarc_header_from_sender);
+    dmarc_policy = DMARC_POLICY_ABSENT;
+    dmarc_status = US"norecord";
+    dmarc_pass_fail = US"none";
+    dmarc_status_text = US"No DMARC record";
+    dmarc_action = DMARC_RESULT_ACCEPT;
+
+    has_dmarc_record = FALSE;
+    }
+
+  else if (!dmarc_local_parse_policy(rr, &dmarc_parsed))
+    {
+    DEBUG(D_receive) debug_printf_indent("DMARC: invalid record found for %s\n",
+					  dmarc_header_from_sender);
+    dmarc_policy = DMARC_POLICY_ABSENT;
+    dmarc_status = US"norecord";
+    dmarc_pass_fail = US"none";
+    dmarc_status_text = US"No DMARC record";
+    dmarc_action = DMARC_RESULT_ACCEPT;
+
+    has_dmarc_record = FALSE;
+    goto out;
+    }
+
+/* RFC 7489 6.6.3 step 6: p/sp checks */
+    if (  !dmarc_parsed.p
+       || !dmarc_tag_vfy_p(dmarc_parsed.p)
+       || dmarc_parsed.sp && !dmarc_tag_vfy_sp(dmarc_parsed.sp)
+       )
+
+/* RFC 7489 6.6.3 step 6: if a valid rua, continue with p=none */
+/*XXX "at least one syntactically valid reporting URI" */
+      if (dmarc_parsed.rua && dmarc_tag_vfy_rua(dmarc_parsed.rua))
+	{
+	DEBUG(D_receive)
+	  debug_printf_indent("DMARC: invalid p or sp; continue for rua\n");
+	dmarc_parsed.p = US"none";
+	}
+      else
+	{
+	DEBUG(D_receive)
+	  debug_printf_indent("DMARC: invalid p or sp, and no rua. Abort.\n");
+	dmarc_abort = TRUE;
+	goto out;
+	}
+
+/* RFC 7489 6.6.2 step 3: Perform DKIM signature verification checks */
+  DEBUG(D_receive)
+    {
+    expand_level--;
+    debug_printf_indent("DMARC: process dkim results\n");
+    expand_level++;
+    }
+
+  /* Now we cycle through the dkim signature results and put into
+  the opendmarc context, further building the DMARC reply. */
+
+  if (has_dmarc_record)
+    for(const pdkim_signature * sig =
+	      (((sigs_fn_t *)dmarc_dkim_mod_info->functions)[DKIM_SIGS_LIST])();
+	sig; sig = sig->next)
+    {
+    int dkim_result, dkim_ares_result, vs, ves;
+
+    dkim_sig_count++;
+    vs  = sig->verify_status & ~PDKIM_VERIFY_POLICY;
+    ves = sig->verify_ext_status;
+    dkim_result = vs == PDKIM_VERIFY_PASS ? DMARC_POLICY_DKIM_OUTCOME_PASS :
+		  vs == PDKIM_VERIFY_FAIL ? DMARC_POLICY_DKIM_OUTCOME_FAIL :
+		  vs == PDKIM_VERIFY_INVALID ? DMARC_POLICY_DKIM_OUTCOME_TMPFAIL :
+		  DMARC_POLICY_DKIM_OUTCOME_NONE;
+
+    DEBUG(D_receive)
+      debug_printf_indent("DMARC: adding DKIM sender domain = %s\n",
+			  sig->domain);
+
+    /* Update the history buffer */
+
+    dkim_ares_result =
+      vs == PDKIM_VERIFY_PASS    ? ARES_RESULT_PASS :
+      vs == PDKIM_VERIFY_FAIL    ? ARES_RESULT_FAIL :
+      vs == PDKIM_VERIFY_NONE    ? ARES_RESULT_NONE :
+      vs == PDKIM_VERIFY_INVALID ?
+       ves == PDKIM_VERIFY_INVALID_PUBKEY_UNAVAILABLE ? ARES_RESULT_PERMERROR :
+       ves == PDKIM_VERIFY_INVALID_BUFFER_SIZE        ? ARES_RESULT_PERMERROR :
+       ves == PDKIM_VERIFY_INVALID_PUBKEY_DNSRECORD   ? ARES_RESULT_PERMERROR :
+       ves == PDKIM_VERIFY_INVALID_PUBKEY_IMPORT      ? ARES_RESULT_PERMERROR :
+       ARES_RESULT_UNKNOWN :
+      ARES_RESULT_UNKNOWN;
+
+    dkim_history_buffer = string_fmt_append(dkim_history_buffer,
+      "dkim %s %s %d\n", sig->domain, sig->selector, dkim_ares_result);
+
+    /* Evaluate the sig vs. dmarc requirements */
+
+/* RFC 7489 3.1.1 if any DKIM signature ... verifies. */
+    if (  !dmarc_alignment_dkim
+       && dkim_result == DMARC_POLICY_DKIM_OUTCOME_PASS
+
+/* RFC 7489 3.1.1 dkim alignment: d= tag in dkim sig */
+/* RFC 7489 3.1.1 dkim alignment: 5322.From domain */
+/* RFC 7489 6.3   adkim: DKIM Identifier Alignment mode */
+
+       && (dmarc_alignment_dkim = identifier_aligned(sig->domain,
+				  dmarc_header_from_sender, dmarc_parsed.adkim))
+       )
+      dmarc_dkim_alignment = DMARC_POLICY_DKIM_ALIGNMENT_PASS;
+    }
+  DEBUG(D_receive) debug_printf_indent("DMARC: %u dkim sig%s\n",
+				dkim_sig_count, dkim_sig_count == 1 ? "" : "s");
+
+  DEBUG(D_receive)
+    {
+    expand_level--;
+    debug_printf_indent("DMARC: process spf results\n");
+    expand_level++;
+    }
+
+/* RFC 7489 6.6.2 step 4: Perform SPF validation checks */
+
+  if (has_dmarc_record)
+    {
+    int spf_result;
+    typedef int (*fn_t)(uschar **);
+
+    /* Use the envelope sender domain for this part of DMARC */
+
+    spf_sender_domain = expand_string(US"$sender_address_domain");
+
+    if (dmarc_spf_mod_info)
+      sr = ((fn_t *) dmarc_spf_mod_info->functions)[SPF_GET_RESULTS]
+							  (&spf_human_readable);
+
+    if (sr == SPF_RESULT_INVALID)
+      {
+      /* No spf data means null envelope sender so generate a domain name
+      from the sender_helo_name  */
+
+      DEBUG(D_receive) debug_printf_indent("DMARC: spf result 'invalid'\n");
+
+      if (!spf_sender_domain || !*spf_sender_domain)
+	{
+	spf_sender_domain = sender_helo_name;
+	log_write(0, LOG_MAIN, "DMARC using synthesized SPF sender domain = %s\n",
+			       spf_sender_domain);
+	}
+      spf_result = DMARC_POLICY_SPF_OUTCOME_NONE;
+      dmarc_spf_ares_result = ARES_RESULT_UNKNOWN;
+      spf_origin = DMARC_POLICY_SPF_ORIGIN_HELO;
+      spf_human_readable = US"";
+      }
+    else
+      {
+      spf_result = sr == SPF_RESULT_NEUTRAL  ? DMARC_POLICY_SPF_OUTCOME_NONE :
+			 sr == SPF_RESULT_PASS     ? DMARC_POLICY_SPF_OUTCOME_PASS :
+			 sr == SPF_RESULT_FAIL     ? DMARC_POLICY_SPF_OUTCOME_FAIL :
+			 sr == SPF_RESULT_SOFTFAIL ? DMARC_POLICY_SPF_OUTCOME_TMPFAIL :
+			 DMARC_POLICY_SPF_OUTCOME_NONE;
+      dmarc_spf_ares_result = sr == SPF_RESULT_NEUTRAL   ? ARES_RESULT_NEUTRAL :
+			      sr == SPF_RESULT_PASS      ? ARES_RESULT_PASS :
+			      sr == SPF_RESULT_FAIL      ? ARES_RESULT_FAIL :
+			      sr == SPF_RESULT_SOFTFAIL  ? ARES_RESULT_SOFTFAIL :
+			      sr == SPF_RESULT_NONE      ? ARES_RESULT_NONE :
+			      sr == SPF_RESULT_TEMPERROR ? ARES_RESULT_TEMPERROR :
+			      sr == SPF_RESULT_PERMERROR ? ARES_RESULT_PERMERROR :
+			      ARES_RESULT_UNKNOWN;
+      /*XXX hmm, spf_origin never used? */
+      spf_origin = DMARC_POLICY_SPF_ORIGIN_MAILFROM;
+      DEBUG(D_receive)
+	debug_printf_indent("DMARC: using SPF sender domain = %s\n",
+					  spf_sender_domain);
+      }
+    if (!spf_sender_domain || !*spf_sender_domain)
+      dmarc_abort = TRUE;
+    if (!dmarc_abort)
+      {
+  /* RFC 7489 3.1.1 spf alignment: the SPF-authenticated domain */
+  /* RFC 7489 3.1.1 spf alignment: 5322.From domain */
+  /* RFC 7489 6.3   aspf: SPF Identifier Alignment mode */
+
+      if (  spf_result == DMARC_POLICY_SPF_OUTCOME_PASS
+	 && (dmarc_alignment_spf = identifier_aligned(spf_sender_domain,
+				  dmarc_header_from_sender, dmarc_parsed.aspf))
+	 )
+	dmarc_spf_alignment = DMARC_POLICY_SPF_ALIGNMENT_PASS;
+      }
+    }
+
+  DEBUG(D_receive)
+    {
+    expand_level--;
+    debug_printf_indent("DMARC: finished spf\n");
+    }
+
+  /* Store the policy string in an expandable variable. */
+
+/* RFC 7489 is unclear how to obtain the policy-string that is to be used.
+The decription of tags p & sp in 6.3 uses the term "domain queried". I assume
+that is the portion of the DNS lookup key *after* the prepended "_dmarc."
+which returned the DMARC RR being used (so it could be the Organizational
+Domain, per 6.6.3 bullet 3, rather than the 5322.From domain).
+
+Given that assumption: if dom-used != 5322.From.dom and there is an sp,
+use the sp.  Otherwise use the p. */
+
+  dmarc_domain_policy = dmarc_parsed.sp
+			&& dmarc_used_domain != dmarc_header_from_sender
+		      ? dmarc_parsed.sp : dmarc_parsed.p;
+
+/* RFC 7489 6.6.2 step 5 - if either the spf or dkim shows alignment, pass */
+  if (dmarc_alignment_spf || dmarc_alignment_dkim)
+    {							/* Explicit accept */
+    dmarc_policy = DMARC_POLICY_PASS;
+    dmarc_status = US"accept";
+    dmarc_pass_fail = US"pass";
+    dmarc_status_text = US"Accept";
+    dmarc_action = DMARC_RESULT_ACCEPT;
+    }
+
+/* RFC 7489 6.6.2 step 6 - dispose of no-alignment per discovered policy */
+  else
+    {
+    dmarc_status = dmarc_domain_policy;
+    if (Ustrcmp(dmarc_domain_policy, "none") == 0)
+      {							/* Accept and report */
+      dmarc_policy = DMARC_POLICY_NONE;
+      dmarc_pass_fail = US"none";
+      dmarc_status_text = US"None, Accept";
+      dmarc_action = DMARC_RESULT_ACCEPT;
+      }
+    else if (Ustrcmp(dmarc_domain_policy, "quarantine") == 0)
+      {							/* Explicit quarantine*/
+      dmarc_policy = DMARC_POLICY_QUARANTINE;
+      dmarc_pass_fail = US"fail";
+      dmarc_status_text = US"Quarantine";
+      dmarc_action = DMARC_RESULT_QUARANTINE;
+      }
+    else if (Ustrcmp(dmarc_domain_policy, "reject") == 0)
+      {							/* Explicit reject */
+      dmarc_policy = DMARC_POLICY_REJECT;
+      dmarc_pass_fail = US"fail";
+      dmarc_status_text = US"Reject";
+      dmarc_action = DMARC_RESULT_REJECT;
+      }
+    else	/* should never happen; tag values were validated */
+      {		/* could use similar for dns tmpfail */
+      dmarc_status = dmarc_pass_fail = US"temperror";
+      dmarc_status_text = US"Internal Policy Error";
+      dmarc_action = DMARC_RESULT_TEMPFAIL;
+      }
+    }
+
+  // the alignments would be results of the DMARC evaluation
+  // - we have them already, from the dkim & spf processing
+
+  if (has_dmarc_record && !dmarc_abort)
+    {
+    /* Log results.  Robably should have a log_selector to reduce noise. */
+
+    log_write(0, LOG_MAIN, "DMARC results: spf_domain=%s dmarc_domain=%s "
+			   "spf_align=%s dkim_align=%s enforcement='%s'",
+			   spf_sender_domain, dmarc_used_domain,
+			   dmarc_alignment_spf  ? "yes" : "no",
+			   dmarc_alignment_dkim ? "yes" : "no",
+			   dmarc_status_text);
+
+
+    /* History file, for later aggregate reporting. */
+
+    dmarc_pct = atoi(CCS dmarc_parsed.pct);
+
+    dmarc_adkim = dmarc_parsed.adkim
+		? *dmarc_parsed.adkim : DMARC_RECORD_A_UNSPECIFIED;
+    dmarc_aspf = dmarc_parsed.aspf 
+		? *dmarc_parsed.aspf : DMARC_RECORD_A_UNSPECIFIED;
+    dmarc_dom_policy = dmarc_parsed.p
+		? *dmarc_parsed.p : DMARC_RECORD_P_UNSPECIFIED;
+    dmarc_subdom_policy = dmarc_parsed.sp
+		? *dmarc_parsed.sp : DMARC_RECORD_P_UNSPECIFIED;
+
+/* RFC 7489 6.3 - rua is a comma-sep list */
+    dmarc_rua = dmarc_clist_to_array(dmarc_parsed.rua);
+
+    dmarc_write_history_file(dkim_history_buffer);
+
+    /* Forensic reporting */
+
+    dmarc_maybe_send_forensic(dmarc_parsed.ruf);
+    }
+  }
+
+out:
+  DEBUG(D_receive)
+    {
+    expand_level--;
+    debug_printf_indent("DMARC: finished process, status %q\n", dmarc_status);
+    }
+  return OK;
+}
+
+static const uschar *
+dmarc_exim_expand_defaults(void)
+{
+return f.dmarc_disable_verify ?  US"off" : US"none";
+}
+
+/*API*/
+const uschar *
+dmarc_exim_expand_query(void)
+{
+if (f.dmarc_disable_verify )            // || !dmarc_pctx)
+  return dmarc_exim_expand_defaults();
+
+return dmarc_status;
+}
+
+
+# endif /* have SPF & DKIM */
+#endif /* EXPERIMENTAL_DMARC_NATIVE */
+/* vi: aw ai sw=2
+ */
diff --git a/src/src/miscmods/spf.c b/src/src/miscmods/spf.c
index 9d215f516..f73a8776b 100644
--- a/src/src/miscmods/spf.c
+++ b/src/src/miscmods/spf.c
@@ -84,18 +84,18 @@ SPF_dns_rr_t srr = {
   .source = spf_dns_server
 };
 
-DEBUG(D_receive) debug_printf("SPF_dns_exim_lookup '%s'\n", domain);
+DEBUG(D_receive)
+  { debug_printf_indent("SPF_dns_exim_lookup '%s'\n", domain); expand_level++; }
 
 /* Shortcircuit SPF RR lookups by returning NO_DATA.  They were obsoleted by
 RFC 6686/7208 years ago. see bug #1294 */
 
 if (rr_type == T_SPF)
   {
-  HDEBUG(D_host_lookup) debug_printf("faking NO_DATA for SPF RR(99) lookup\n");
+  HDEBUG(D_host_lookup)
+    debug_printf_indent("faking NO_DATA for SPF RR(99) lookup\n");
   srr.herrno = NO_DATA;
-  SPF_dns_rr_dup(&spfrr, &srr);
-  store_free_dns_answer(dnsa);
-  return spfrr;
+  goto out;
   }
 
 switch (dns_lookup(dnsa, US domain, rr_type, NULL))
@@ -115,11 +115,7 @@ switch (dns_lookup(dnsa, US domain, rr_type, NULL))
   }
 
 if (found == 0)
-  {
-  SPF_dns_rr_dup(&spfrr, &srr);
-  store_free_dns_answer(dnsa);
-  return spfrr;
-  }
+  goto out;
 
 srr.rr = store_malloc(sizeof(SPF_dns_rr_data_t) * found);
 
@@ -153,8 +149,8 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
 	if (rr->size < 1+6) continue;		/* min for version str */
 	if (strncmpic(rr->data+1, US SPF_VER_STR, 6) != 0)
 	  {
-	  HDEBUG(D_host_lookup) debug_printf("not an spf record: %.*s\n",
-	    (int) s[0], s+1);
+	  HDEBUG(D_host_lookup) debug_printf_indent("not an spf record: %.*s\n",
+						    (int) s[0], s+1);
 	  continue;
 	  }
 
@@ -170,7 +166,7 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
 	  continue;
 	gstring_release_unused(g);
 	s = string_copy_malloc(string_from_gstring(g));
-	DEBUG(D_receive) debug_printf("SPF_dns_exim_lookup '%s'\n", s);
+	DEBUG(D_receive) debug_printf_indent("SPF_dns_exim_lookup '%s'\n", s);
 	break;
 	}
 
@@ -192,10 +188,13 @@ empty ANSWER section. */
 if (!(srr.num_rr = found))
   srr.herrno = NO_DATA;
 
-/* spfrr->rr must have been malloc()d for this */
-SPF_dns_rr_dup(&spfrr, &srr);
-store_free_dns_answer(dnsa);
-return spfrr;
+out:
+  /* spfrr->rr must have been malloc()d for this */
+  SPF_dns_rr_dup(&spfrr, &srr);
+
+  DEBUG(D_receive) expand_level--;
+  store_free_dns_answer(dnsa);
+  return spfrr;
 }
 
 
@@ -205,7 +204,7 @@ SPF_dns_exim_new(int debug)
 {
 SPF_dns_server_t * spf_dns_server = store_malloc(sizeof(SPF_dns_server_t));
 
-/* DEBUG(D_receive) debug_printf("SPF_dns_exim_new\n"); */
+/* DEBUG(D_receive) debug_printf_indent("SPF_dns_exim_new\n"); */
 
 memset(spf_dns_server, 0, sizeof(SPF_dns_server_t));
 spf_dns_server->destroy      = NULL;
@@ -252,17 +251,17 @@ testsuite. */
 
 if (!(dc = SPF_dns_exim_new(debug)))
   {
-  DEBUG(D_receive) debug_printf("spf: SPF_dns_exim_new() failed\n");
+  DEBUG(D_receive) debug_printf_indent("SPF_dns_exim_new() failed\n");
   return FALSE;
   }
 if (!(dc = SPF_dns_cache_new(dc, NULL, debug, 8)))
   {
-  DEBUG(D_receive) debug_printf("spf: SPF_dns_cache_new() failed\n");
+  DEBUG(D_receive) debug_printf_indent("SPF_dns_cache_new() failed\n");
   return FALSE;
   }
 if (!(spf_server = SPF_server_new_dns(dc, debug)))
   {
-  DEBUG(D_receive) debug_printf("spf: SPF_server_new() failed.\n");
+  DEBUG(D_receive) debug_printf_indent("SPF_server_new() failed.\n");
   return FALSE;
   }
 
@@ -294,8 +293,8 @@ static int
 spf_conn_init(const uschar * spf_helo_domain, const uschar * spf_remote_addr,
   const uschar ** errstr)
 {
-DEBUG(D_receive)
-  debug_printf("spf_conn_init: %s %s\n", spf_helo_domain, spf_remote_addr);
+DEBUG(D_receive) debug_printf_indent("spf_conn_init: %s %s\n",
+				      spf_helo_domain, spf_remote_addr);
 
 if (!spf_server && !spf_init(NULL))
   {
@@ -305,8 +304,8 @@ if (!spf_server && !spf_init(NULL))
 
 if (SPF_server_set_rec_dom(spf_server, CS primary_hostname))
   {
-  DEBUG(D_receive) debug_printf("spf: SPF_server_set_rec_dom(%q) failed.\n",
-    primary_hostname);
+  DEBUG(D_receive) debug_printf_indent("SPF_server_set_rec_dom(%q) failed.\n",
+					primary_hostname);
   spf_server = NULL;
   *errstr = US"spf: setting host name";
   return FAIL;
@@ -319,7 +318,7 @@ if (  SPF_request_set_ipv4_str(spf_request, CCS spf_remote_addr)
    )
   {
   DEBUG(D_receive)
-    debug_printf("spf: SPF_request_set_ipv4_str() and "
+    debug_printf_indent("SPF_request_set_ipv4_str() and "
       "SPF_request_set_ipv6_str() failed [%s]\n", spf_remote_addr);
   spf_server = NULL;
   spf_request = NULL;
@@ -329,8 +328,8 @@ if (  SPF_request_set_ipv4_str(spf_request, CCS spf_remote_addr)
 
 if (SPF_request_set_helo_dom(spf_request, CCS spf_helo_domain))
   {
-  DEBUG(D_receive) debug_printf("spf: SPF_set_helo_dom(%q) failed.\n",
-    spf_helo_domain);
+  DEBUG(D_receive) debug_printf_indent("SPF_set_helo_dom(%q) failed.\n",
+				      spf_helo_domain);
   spf_server = NULL;
   spf_request = NULL;
   *errstr = US"spf: setting helo string";
@@ -352,14 +351,14 @@ static void
 spf_response_debug(SPF_response_t * spf_response)
 {
 if (SPF_response_messages(spf_response) == 0)
-  debug_printf(" (no errors)\n");
+  debug_printf_indent(" (no errors)\n");
 else for (int i = 0; i < SPF_response_messages(spf_response); i++)
   {
   SPF_error_t * err = SPF_response_message(spf_response, i);
-  debug_printf( "%s_msg = (%d) %s\n",
-		  (SPF_error_errorp(err) ? "warn" : "err"),
-		  SPF_error_code(err),
-		  SPF_error_message(err));
+  debug_printf_indent("%s_msg = (%d) %s\n",
+		      SPF_error_errorp(err) ? "warn" : "err",
+		      SPF_error_code(err),
+		      SPF_error_message(err));
   }
 }
 
@@ -375,11 +374,11 @@ spf_process(const uschar ** listptr, const uschar * spf_envelope_sender,
   int action)
 {
 int sep = 0;
-const uschar *list = *listptr;
-uschar *spf_result_id;
-int rc = SPF_RESULT_PERMERROR;
+const uschar * list = * listptr;
+uschar * spf_result_id;
+int rc = SPF_RESULT_PERMERROR, ret = OK;
 
-DEBUG(D_receive) debug_printf("spf_process\n");
+DEBUG(D_receive) { debug_printf_indent("SPF: process\n"); expand_level++; }
 
 if (!(spf_server && spf_request))
   /* no global context, assume temp error and skip to evaluation */
@@ -412,24 +411,32 @@ else
   }
 
 /* We got a result. Now see if we should return OK or FAIL for it */
-DEBUG(D_acl) debug_printf("SPF result is %s (%d)\n", SPF_strresult(rc), rc);
+DEBUG(D_acl)
+  debug_printf_indent("SPF: result is %s (%d)\n", SPF_strresult(rc), rc);
 
 if (action == SPF_PROCESS_GUESS && (!strcmp (SPF_strresult(rc), "none")))
-  return spf_process(listptr, spf_envelope_sender, SPF_PROCESS_FALLBACK);
+  ret = spf_process(listptr, spf_envelope_sender, SPF_PROCESS_FALLBACK);
 
-while ((spf_result_id = string_nextinlist(&list, &sep, NULL, 0)))
+else
   {
-  BOOL negate, result;
+  while ((spf_result_id = string_nextinlist(&list, &sep, NULL, 0)))
+    {
+    BOOL negate, result;
 
-  if ((negate = spf_result_id[0] == '!'))
-    spf_result_id++;
+    if ((negate = spf_result_id[0] == '!'))
+      spf_result_id++;
+
+    result = Ustrcmp(spf_result_id, spf_result_id_list[rc].name) == 0;
+    if (negate != result) goto out;
+    }
 
-  result = Ustrcmp(spf_result_id, spf_result_id_list[rc].name) == 0;
-  if (negate != result) return OK;
+  /* no match */
+  ret = FAIL;
   }
 
-/* no match */
-return FAIL;
+out:
+  DEBUG(D_receive) expand_level--;
+  return ret;
 }
 
 
@@ -457,11 +464,11 @@ if (spf_result)
       ? string_append(g, 2, US" smtp.helo=", s)
       : string_cat(g, US" smtp.mailfrom=<>");
     }
-  DEBUG(D_acl) debug_printf("SPF:\tauthres '%.*s'\n",
+  DEBUG(D_acl) debug_printf_indent("SPF:\tauthres '%.*s'\n",
 		  gstring_length(g) - start - 3, g->s + start + 3);
   }
 else
-  DEBUG(D_acl) debug_printf("SPF:\tno authres\n");
+  DEBUG(D_acl) debug_printf_indent("SPF:\tno authres\n");
 return g;
 }
 
@@ -478,7 +485,7 @@ if (spf_response)
   s = US spf_response->header_comment;
   }
 *human_readable_p = s ? string_copy(s) : US"";
-DEBUG(D_acl) debug_printf("SPF: %d '%s'\n", res, s);
+DEBUG(D_acl) debug_printf_indent(" SPF: %d '%s'\n", res, s);
 return res;
 }
 
